/*
 * Copyright (c) 2020-2021 Advanced Robotics at the University of Washington <robomstr@uw.edu>
 *
 * This file is part of aruw-mcb.
 *
 * aruw-mcb is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * aruw-mcb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with aruw-mcb.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef SPLASH_SCREEN_LOGO_HPP_
#define SPLASH_SCREEN_LOGO_HPP_

#include "aruwsrc/util_macros.hpp"
#include "modm/architecture/interface/accessor_flash.hpp"

namespace aruwsrc::display
{
#ifdef SSH1106_OLED
FLASH_STORAGE(uint8_t ARUW_IMAGE_128X64[]) = {
    128, 64,  0,   0,   0,   0,   0,   0,   0,   0,   0,   128, 248, 240, 224, 192, 128, 0,   0,
    0,   0,   192, 248, 254, 248, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   128, 128, 192, 192, 192, 224, 224, 240, 240, 248, 248,
    248, 248, 240, 0,   0,   0,   0,   0,   192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
    192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 0,   0,   0,   0,   0,   0,   0,   0,
    192, 192, 192, 192, 192, 192, 192, 192, 0,   0,   0,   0,   0,   0,   0,   0,   192, 192, 192,
    192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   255, 255, 255, 255, 1,   3,   7,   14,  28,  56,  115, 247, 243,
    249, 253, 252, 252, 252, 252, 254, 254, 255, 255, 127, 127, 127, 127, 63,  63,  63,  62,  190,
    254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 63,  31,  7,   0,   0,
    0,   0,   0,   255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 0,   0,   0,   0,   0,   0,   0,   248, 255, 255, 255, 255, 255,
    255, 255, 255, 248, 0,   0,   0,   0,   0,   0,   0,   255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 0,   0,   0,   0,   0,   128, 128, 128, 128, 192, 192,
    252, 252, 249, 243, 231, 79,  30,  252, 240, 240, 248, 254, 255, 255, 255, 255, 255, 255, 31,
    1,   241, 252, 12,  192, 248, 120, 0,   128, 248, 252, 254, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 127, 31,  15,  7,   3,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   31,  255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 224, 0,   0,   0,
    0,   0,   0,   0,   0,   0,   224, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    224, 0,   0,   0,   0,   0,   0,   0,   0,   128, 252, 255, 255, 255, 255, 255, 255, 63,  3,
    0,   0,   0,   0,   0,   0,   0,   7,   15,  31,  31,  255, 255, 255, 255, 255, 255, 255, 7,
    224, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 15,  0,   224, 255, 15,  192, 252, 127,
    15,  128, 248, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 252, 254, 254,
    254, 254, 254, 255, 127, 127, 127, 127, 63,  15,  0,   0,   0,   0,   0,   0,   0,   0,   0,
    3,   31,  255, 255, 255, 255, 255, 255, 255, 255, 255, 252, 128, 0,   0,   0,   0,   0,   128,
    252, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 252, 128, 0,   0,
    0,   0,   0,   240, 255, 255, 255, 255, 255, 255, 63,  3,   0,   0,   0,   0,   0,   0,   0,
    0,   28,  63,  63,  63,  127, 255, 255, 255, 255, 255, 255, 255, 240, 128, 31,  255, 255, 255,
    255, 255, 255, 31,  15,  193, 120, 30,  135, 240, 252, 63,  15,  192, 252, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 251, 227, 195, 3,   1,   1,   1,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   3,   63,  255,
    255, 255, 255, 255, 255, 255, 255, 255, 240, 0,   0,   128, 240, 255, 255, 255, 255, 127, 7,
    0,   7,   127, 255, 255, 255, 255, 255, 255, 255, 255, 255, 248, 128, 0,   192, 254, 255, 255,
    255, 255, 255, 63,  3,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   112, 248,
    252, 255, 255, 255, 255, 255, 255, 255, 255, 255, 254, 248, 241, 227, 143, 143, 1,   96,  126,
    7,   128, 252, 255, 15,  199, 240, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 254, 248, 240, 192, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   15,  255, 255, 255, 255, 255,
    255, 255, 255, 255, 254, 248, 255, 255, 255, 255, 255, 15,  0,   0,   0,   0,   0,   15,  255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 248, 255, 255, 255, 255, 255, 63,  3,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,
    1,   1,   3,   255, 255, 255, 255, 255, 255, 255, 255, 255, 254, 252, 252, 249, 249, 248, 240,
    243, 243, 135, 7,   255, 255, 255, 63,  63,  127, 127, 255, 255, 255, 255, 255, 195, 3,   7,
    15,  15,  31,  63,  127, 248, 240, 128, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   7,   255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 63,  1,   0,   0,   0,   0,   0,   0,   0,   1,   63,  255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 127, 7,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   3,   7,
    7,   7,   3,   1,   1,   1,   1,   3,   3,   255, 255, 255, 255, 255, 31,  31,  15,  0,   15,
    255, 127, 0,   0,   0,   0,   0,   1,   3,   7,   15,  63,  0,   0,   0,   0,   0,   0,   0,
    0,   3,   7,   14,  24,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   7,   7,   7,   7,   7,   7,   7,   7,   7,
    7,   7,   7,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0};
#else

FLASH_STORAGE(uint8_t ARUW_IMAGE_128X128[]) = {
    128, 128, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   128, 224, 252,
    255, 255, 255, 127, 126, 252, 240, 192, 128, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   192, 224, 248, 254, 255, 224, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   192, 240, 254, 255, 255, 255, 255, 255, 15,  0,   0,
    1,   7,   31,  127, 254, 248, 240, 192, 0,   0,   0,   96,  248, 252, 255, 255, 255, 255, 255,
    255, 255, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   128, 128, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    32,  120, 255, 255, 255, 255, 255, 255, 255, 255, 243, 128, 0,   0,   0,   0,   0,   0,   0,
    3,   15,  63,  255, 254, 248, 224, 225, 227, 227, 227, 227, 227, 227, 243, 243, 240, 240, 240,
    240, 240, 248, 248, 248, 248, 248, 248, 252, 252, 248, 248, 248, 248, 240, 240, 240, 224, 224,
    224, 192, 192, 192, 192, 128, 128, 128, 0,   0,   0,   0,   0,   0,   128, 128, 128, 128, 128,
    128, 192, 192, 192, 192, 192, 192, 224, 224, 224, 224, 224, 224, 240, 240, 240, 240, 240, 240,
    248, 248, 248, 248, 224, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   112, 252, 254, 255,
    255, 255, 255, 255, 255, 254, 254, 254, 254, 254, 254, 252, 248, 240, 224, 192, 128, 1,   3,
    7,   31,  63,  127, 255, 255, 255, 254, 248, 192, 0,   0,   128, 192, 224, 240, 248, 252, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 127, 127, 127, 127, 127, 127, 127, 127, 127, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 127,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   3,   7,   15,  159, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 254, 124, 24,  0,   0,   0,
    129, 195, 231, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 127, 30,  12,  0,   0,   192, 224, 240, 96,  32,  0,   0,   0,   128, 0,
    0,   0,   0,   0,   0,   0,   128, 224, 240, 252, 254, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 127, 63,  31,  7,   3,   0,   0,   0,   0,   0,   0,
    128, 128, 128, 128, 128, 128, 128, 192, 240, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 63,  15,  3,   0,   0,   192, 240, 252, 254, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 127, 31,  15,  3,   0,   192,
    224, 248, 124, 63,  15,  3,   1,   128, 224, 240, 252, 63,  15,  7,   1,   128, 192, 240, 252,
    254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 127, 127, 63,  31,  31,  15,  7,
    3,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   252, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 15,  0,
    0,   0,   224, 252, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 127, 31,  15,  3,   0,   128, 224, 248, 252, 63,  15,  7,   1,   128, 192, 240,
    252, 126, 31,  7,   3,   0,   192, 240, 248, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 127, 127, 63,  31,
    15,  15,  7,   3,   3,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   1,   1,   3,   3,   7,   7,   7,   15,  255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 1,   0,   0,   0,   252, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 127, 31,  15,  3,   1,   128, 224,
    248, 252, 63,  31,  7,   1,   0,   192, 240, 248, 126, 31,  15,  3,   0,   128, 224, 248, 252,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 247, 243, 243, 241, 240, 240, 240, 240, 240, 224, 224, 224, 224, 224,
    224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 192, 192, 192, 128, 0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   128, 128, 192, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 224, 0,   0,   0,   15,  255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 127, 31,  15,  3,   1,   128, 224, 240, 252, 127, 31,  7,   3,   0,   192, 224, 248,
    126, 63,  15,  3,   1,   128, 224, 240, 252, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 127, 31,  7,   3,   0,   0,   0,   0,   0,   28,  252, 254,
    254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 252, 224, 0,   0,   1,   15,  63,  255, 255, 127, 31,  15,  3,   1,   128, 224, 240,
    252, 127, 31,  7,   3,   0,   128, 224, 248, 252, 63,  31,  7,   1,   0,   192, 240, 248, 254,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 129, 1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
    1,   1,   1,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
    1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   7,   7,   7,   7,   7,   7,
    7,   7,   7,   7,   15,  63,  255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    252, 240, 192, 128, 0,   1,   0,   0,   48,  252, 126, 31,  15,  3,   0,   128, 224, 240, 252,
    127, 31,  7,   3,   0,   192, 224, 248, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 240, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   192, 227, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    252, 248, 240, 224, 192, 128, 0,   0,   12,  14,  31,  15,  3,   0,   128, 224, 240, 252, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 254,
    192, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   28,  62,  255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 127, 127, 127, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 254, 254, 252, 248, 248, 240, 240, 224, 224, 1,   1,   3,   3,   7,   255, 255, 255,
    255, 255, 255, 255, 127, 31,  63,  255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 63,  63,  127, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 248, 0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   3,   3,   3,   1,   1,   1,   0,   0,
    0,   0,   0,   0,   1,   3,   7,   15,  31,  255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 0,   0,   0,   0,   255, 255, 255, 255, 255, 31,  7,   1,   0,
    0,   0,   1,   7,   63,  255, 255, 255, 255, 255, 255, 255, 255, 255, 7,   0,   0,   0,   0,
    3,   7,   31,  63,  255, 255, 255, 255, 255, 255, 255, 255, 192, 0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   112, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 127, 63,  31,  31,  31,  31,
    0,   0,   0,   0,   252, 255, 63,  15,  3,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    1,   7,   63,  255, 255, 255, 255, 15,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    3,   7,   31,  63,  255, 255, 255, 255, 248, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    1,   3,   3,   7,   7,   3,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   16,  7,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   7,
    63,  1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    1,   7,   15,  63,  127, 224, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0};
#endif

}  // namespace aruwsrc::display

#endif  // SPLASH_SCREEN_LOGO_HPP_
